<template>
  <frame :modal="modal" noDimmer position="dynamic">
    <div class="font-bold text-xs text-gray-500 text-center p-2 tracking-wide">{{ title }}</div>
    <div class="pb-2 min-w-sm">
      <div @click="tomorrowClick()" class="py-2 px-4 clickable-bg pr-8">
        <i class="hero chevron-right solid mr-2 text-gray-500"></i>
        Tomorrow
      </div>
      <div @click="nextWeekClick()" class="py-2 px-4 clickable-bg">
        <i class="hero chevron-double-right solid mr-2 text-gray-500"></i>
        Next Monday
      </div>
      <div class="border-t pb-2 mt-2"></div>
      <div @click="modals.show('date-picker')" class="py-2 px-4 clickable-bg">
        <i class="hero calendar solid mr-2 text-gray-500"></i>
        {{ pickdateText }}
        <i
          @click.stop="deleteDate()"
          v-if="value != undefined"
          class="hero x solid ml-4 text-gray-500 hover:bg-gray-200 rounded-full p-2 -mr-2"
        ></i>
      </div>
    </div>
    <!-- <div class="mx-8">
      <horizontal-scrolling class="text-sm">
        <tag @click="tomorrowClick()" class="clickable-bg">
          <i class="hero chevron-right solid mr-1 text-blue-500"></i>
          Tomorrow
        </tag>
        <tag @click="nextWeekClick()" class="clickable-bg">
          <i class="hero chevron-double-right solid mr-1 text-blue-500"></i>
          Next Monday
        </tag>
      </horizontal-scrolling>
      <div
        class="mt-4 text-lg text-gray-800 font-light rounded-lg px-4 pl-2 py-2 flex flex-row items-center justify-start clickable"
        @click="modals.show('date-picker', $event)"
      >
        <i class="mr-4 hero calendar solid"></i>
        {{ pickdateText }}
      </div>
    </div> -->

    <modal
      :is="modals.get('date-picker')"
      :value="value"
      @input="pickDate"
      :title="`Select ${title}`"
      location="center"
    />
  </frame>
</template>

<script lang="ts">
import { isModal, useModals } from "@/use/modal";
import DatePicker from "@/components/DatePicker.vue";
import { DateTime } from "luxon";
import HorizontalScrolling from "@/components/HorizontalScrolling.vue";
import Tag from "@/components/Tag.vue";
import { computed, ref, Ref } from "vue";
import Frame from "@/use/modal/components/Frame.vue";

export default {
  mixins: [isModal()],
  components: { HorizontalScrolling, Tag, Frame },
  emits: ["input"],
  props: {
    value: {
      type: DateTime,
      required: false
    },
    title: {
      type: String,
      default: "Date"
    }
  },
  setup(props, context) {
    const modals = useModals({ DatePicker });
    const submitValue = (value: DateTime | null) => {
      context.emit("input", value);
      props.modal.hide();
    };

    return {
      modals,
      pickDate: submitValue,
      deleteDate: () => submitValue(null),
      tomorrowClick: () => submitValue(DateTime.local().plus({ days: 1 })),
      nextWeekClick: () =>
        submitValue(
          DateTime.local()
            .startOf("week")
            .plus({ weeks: 1 })
        ),
      pickdateText: computed(() => {
        if (props.value == undefined) {
          return "Choose a date";
        }

        return props.value.toLocaleString({ weekday: "short", month: "short", day: "2-digit" });
      })
    };
  }
};
</script>
